c     Copyright (c) 2001-2004 The Trustees of Indiana University.  
c                             All rights reserved.
c     Copyright (c) 1998-2001 University of Notre Dame. 
c                             All rights reserved.
c     Copyright (c) 1994-1998 The Ohio State University.  
c                             All rights reserved.
c 
c     This file is part of the LAM/MPI software package.  For license
c     information, see the LICENSE file in the top level directory of the
c     LAM/MPI source distribution.
c 
c     $HEADER$
c
c     $Id: attrsetget.c,v 1.4 2002/10/09 20:55:30 brbarret Exp $
c
c     This contains the Fortran counterpart of setting and getting attribute
c     from a comm. They will call the corresponding C functions to test
c     language interoperability for attributes
c
c     This test has used deprecated functions for get_attr in fortran, to
c     test the use of union in the internal fortran MPI function
c

      program main
      integer ierr
      integer key, ckey
      logical flag
      integer rank, size
      integer attr
      integer newattr
      integer extra_state

      include 'mpif.h'

c     Init MPI

      call MPI_Init( ierr )
      call MPI_Comm_size( MPI_COMM_WORLD, size, ierr)
      call MPI_Comm_rank( MPI_COMM_WORLD, rank, ierr)

c     Create keyval in Fortran

      call MPI_Comm_create_keyval(MPI_COMM_NULL_COPY_FN, 
     +     MPI_COMM_NULL_DELETE_FN, key, extra_state, ierr)

c     Setting and getting from Fortran

      attr = 1234
      call MPI_Comm_set_attr(MPI_COMM_WORLD, key, attr, ierr)
      call MPI_Comm_get_attr(MPI_COMM_WORLD, key, newattr,
     +     flag, ierr)

      if (newattr .ne. attr)then
         call lamtest_error_f('Error in set/get attribute')
      endif

c     Setting in C and getting from Fortran

      attr = 5678
      call attr_set_c(key, attr)
      call MPI_Attr_get(MPI_COMM_WORLD, key, newattr, 
     +     flag, ierr)

      if (newattr .ne. attr)then
         call lamtest_error_f('Error in C set/ F get attribute')
      endif

c     Setting in Fortran and getting from C

      attr = 1177

      call MPI_Comm_set_attr(MPI_COMM_WORLD, key, attr, ierr)
      call attr_get_c(key, attr)


c     Creating key in C , setting in C and getting from fortran

      call create_keyval_c(ckey)
      
      attr = 8888
      call attr_set_c(ckey, attr)
      call MPI_Attr_get(MPI_COMM_WORLD, ckey, newattr,
     +     flag, ierr)

      if (newattr .ne. attr)then
         call lamtest_error_f('Error in C set/ F get attribute')
      endif
      
c     Finalize MPI
      call MPI_Finalize( ierr )

      end
